/*
 *
 *      Copyright (c) 1994 by Borland International
 *      All Rights Reserved.
 *
 * modified by George Byrkit to correct lack of __cplusplus mangling protection
 *
 */

#ifndef _LOWMEM_H
#define _LOWMEM_H

#ifdef __cplusplus
extern "C" {            /* Assume C declarations for C++ */
#endif  /* __cplusplus */

#include <dos.h>

#if     defined(__DPMI32__)

unsigned short ReturnLowMemSel ( void );
unsigned long ReturnLowMemFailureCode ( void );

void    setToLow ( unsigned short dst_sel, unsigned short dst_offset,
	unsigned char value, unsigned int size );
void copyToLow ( unsigned short dst_seg, unsigned short dst_offset,
		void * src,
		unsigned int size );
void copyFromLow ( void * dst,
		unsigned short src_seg, unsigned short src_offset,
		unsigned int size);

unsigned long  getLowMemDword(unsigned short seg, unsigned short offset);
unsigned short getLowMemWord(unsigned short seg, unsigned short offset);
unsigned char  getLowMemByte(unsigned short seg, unsigned short offset);

void setLowMemDword(unsigned short seg, unsigned short ofst, unsigned long dw);
void setLowMemWord (unsigned short seg, unsigned short ofst, unsigned short w);
void setLowMemByte (unsigned short seg, unsigned short ofst, unsigned char  c);

#else

#if defined(__DPMI16__)

extern unsigned short getSelFor(unsigned short seg);

#else

#define getSelFor(seg) (seg)

#endif

#define setLowMemByte(seg, ofst, b) (*((unsigned char far * ) MK_FP(getSelFor(seg),ofst)) = b)
#define setLowMemWord(seg, ofst, w) (*((unsigned short far *) MK_FP(getSelFor(seg),ofst)) = w)
#define setLowMemDword(seg, ofst, d)(*((unsigned long far * ) MK_FP(getSelFor(seg),ofst)) = d)

#define getLowMemByte(seg, ofst) (*((unsigned char far * ) MK_FP(getSelFor(seg),ofst)))
#define getLowMemWord(seg, ofst) (*((unsigned short far *) MK_FP(getSelFor(seg),ofst)))
#define getLowMemDword(seg, ofst)(*((unsigned long far * ) MK_FP(getSelFor(seg),ofst)))

#define copyToLow(dst_seg,dst_offset,src,size)   _fmemcpy(MK_FP(getSelFor(dst_seg),dst_offset), src, size)
#define copyFromLow(dst,src_seg,src_offset,size) _fmemcpy(dst, MK_FP(getSelFor(src_seg),src_offset), size)

#endif

#ifdef __cplusplus
}                       /* End of extern "C" { */
#endif	/* __cplusplus */

#endif	/* lowmem.h multiple inclusion guard */
